package lcsb.mapviewer.api;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.context.request.WebRequest;

public abstract class BaseController {
	Logger logger = Logger.getLogger(BaseController.class);

	@ExceptionHandler({ Exception.class })
	public ResponseEntity<Object> handleException(Exception e, WebRequest request) {
		logger.error(e, e);
		if (e instanceof SecurityException) {
			return new ResponseEntity<Object>("{\"error\" : \"Access denied.\",\"reason\":\"" + e.getMessage() + "\"}", new HttpHeaders(), HttpStatus.FORBIDDEN);
		} else if (e instanceof QueryException) {
			return new ResponseEntity<Object>(
					"{\"error\" : \"Query server error.\",\"reason\":\"" + e.getMessage() + "\"}", new HttpHeaders(), HttpStatus.BAD_REQUEST);
		} else {
			return new ResponseEntity<Object>(
					"{\"error\" : \"Internal server error.\",\"reason\":\"" + e.getMessage() + "\"}", new HttpHeaders(), HttpStatus.INTERNAL_SERVER_ERROR);
		}
	}


}
