package lcsb.mapviewer.api.projects.models.bioEntities.elements;

import static org.junit.Assert.assertFalse;
import static org.mockito.Matchers.any;
import static org.mockito.Matchers.anyString;

import java.util.Map;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.Test;
import org.mockito.Mockito;
import org.springframework.beans.factory.annotation.Autowired;

import lcsb.mapviewer.api.RestTestFunctions;
import lcsb.mapviewer.api.projects.models.bioEntities.elements.ElementsRestImpl;
import lcsb.mapviewer.model.map.model.Model;
import lcsb.mapviewer.services.interfaces.IModelService;

public class ElementRestImplTest extends RestTestFunctions {

	@Autowired
	ElementsRestImpl _elementsRestImpl;

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void testGetElementsProcessAllColumns() throws Exception {
		try {
			ElementsRestImpl projectRest = createMockProjectRest("testFiles/model/sample.xml");
			for (Map<String, Object> element : projectRest.getElements("sample", "", "", "*", token.getId())) {
				for (String paramName : element.keySet()) {
					Object val = element.get(paramName);
					String paramValue = "";
					if (val != null) {
						paramValue = val.toString();
					}
					assertFalse("Improper handler for column name: " + paramName, paramValue.contains("Unknown column"));
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
			throw e;
		}
	}

	private ElementsRestImpl createMockProjectRest(String string) throws Exception {
		Model model = super.getModelForFile(string, true);
		IModelService mockModelService = Mockito.mock(IModelService.class);
		Mockito.when(mockModelService.getLastModelByProjectId(anyString(), any())).thenReturn(model);
		_elementsRestImpl.setModelService(mockModelService);
		return _elementsRestImpl;
	}

}
